function inArray(needle, haystack) {
    var length = haystack.length;
    for(var i = 0; i < length; i++) {
        if(haystack[i] == needle) return true;
    }
    return false;
}

function IsEmpty(aTextField) {
    if (typeof(aTextField) == "undefined") {
        return false;
    }
    
    if ((aTextField.length==0) ||
        (aTextField==null)) {
        return true;
    }
    else {
        return false;
    }
}

function trim(str) {
    return str.replace(/^\s+|\s+$/g,"");
}

function getRandomString(n) {
    var chars = "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ".split("");
    var count = chars.length;
    var str = "";

    for (var i = 0; i < n; i++)
        str += chars[Math.floor(Math.random() * count)];

    return str;
}

function getGoogleCaptchaBytes(callback) {
    use_("http-request", function (hr) {
        var req = new hr.Request();
        var id = Math.floor(Math.random() * 10000000000000000);
        
        var url = "http://" + "www.google.com" + "/sorry/image?id=" + id;
    
        req.open("get", url);
        req.send(function () {
            if (this.status != 200)
                fetchCaptcha(callback);
            else
                callback(id, this.responseBody);
    
            this.dispose();
        });
    
        req = null;
    });
}

function strip_tags (input, allowed) {
  allowed = (((allowed || "") + "").toLowerCase().match(/<[a-z][a-z0-9]*>/g) || []).join(''); // making sure the allowed arg is a string containing only tags in lowercase (<a><b><c>)
  var tags = /<\/?([a-z][a-z0-9]*)\b[^>]*>/gi,
    commentsAndPhpTags = /<!--[\s\S]*?-->|<\?(?:php)?[\s\S]*?\?>/gi;
  return input.replace(commentsAndPhpTags, '').replace(tags, function ($0, $1) {
    return allowed.indexOf('<' + $1.toLowerCase() + '>') > -1 ? $0 : '';
  });
}

function checkURL(value) {
    var urlregex = new RegExp("^(http:\/\/www.|https:\/\/www.|ftp:\/\/www.|www.){1}([0-9A-Za-z]+\.)");
    if (urlregex.test(value)) {
        return (true);
    }
    return (false);
}

function parseURL(url){
    parsed_url = {}

    if ( url == null || url.length == 0 )
        return parsed_url;

    protocol_i = url.indexOf('://');
    parsed_url.protocol = url.substr(0,protocol_i);

    remaining_url = url.substr(protocol_i + 3, url.length);
    domain_i = remaining_url.indexOf('/');
    domain_i = domain_i == -1 ? remaining_url.length - 1 : domain_i;
    parsed_url.domain = remaining_url.substr(0, domain_i);
    parsed_url.path = domain_i == -1 || domain_i + 1 == remaining_url.length ? null : remaining_url.substr(domain_i + 1, remaining_url.length);

    domain_parts = parsed_url.domain.split('.');
    switch ( domain_parts.length ){
        case 2:
          parsed_url.subdomain = null;
          parsed_url.host = domain_parts[0];
          parsed_url.tld = domain_parts[1];
          break;
        case 3:
          parsed_url.subdomain = domain_parts[0];
          parsed_url.host = domain_parts[1];
          parsed_url.tld = domain_parts[2];
          break;
        case 4:
          parsed_url.subdomain = domain_parts[0];
          parsed_url.host = domain_parts[1];
          parsed_url.tld = domain_parts[2] + '.' + domain_parts[3];
          break;
    }

    parsed_url.parent_domain = parsed_url.host + '.' + parsed_url.tld;

    return parsed_url;
}

function number_format (number, decimals, dec_point, thousands_sep) {
    var n = number, prec = decimals;
    
    var toFixedFix = function (n,prec) {
        var k = Math.pow(10,prec);
        return (Math.round(n*k)/k).toString();
    };
    
    n = !isFinite(+n) ? 0 : +n;
    prec = !isFinite(+prec) ? 0 : Math.abs(prec);
    var sep = (typeof thousands_sep === 'undefined') ? ',' : thousands_sep;
    var dec = (typeof dec_point === 'undefined') ? '.' : dec_point;
    
    var s = (prec > 0) ? toFixedFix(n, prec) : toFixedFix(Math.round(n), prec); //fix for IE parseFloat(0.55).toFixed(0) = 0;
    
    var abs = toFixedFix(Math.abs(n), prec);
    var _, i;
    
    if (abs >= 1000) {
        _ = abs.split(/\D/);
        i = _[0].length % 3 || 3;
    
        _[0] = s.slice(0,i + (n < 0)) +
              _[0].slice(i).replace(/(\d{3})/g, sep+'$1');
        s = _.join(dec);
    } else {
        s = s.replace('.', dec);
    }
    
    var decPos = s.indexOf(dec);
    if (prec >= 1 && decPos !== -1 && (s.length-decPos-1) < prec) {
        s += new Array(prec-(s.length-decPos-1)).join(0)+'0';
    }
    else if (prec >= 1 && decPos === -1) {
        s += dec+new Array(prec).join(0)+'0';
    }
    return s;
}

function IsJsonString(str) {
    try {
        JSON.parse(str);
    } catch (e) {
        return false;
    }
    return true;
}

function removeDuplicate(arr) {
    var hasOwnProperty = Object.prototype.hasOwnProperty;

    var map = {};

    for (var i = 0; i < arr.length; i++) {
        if (typeof arr[i] != "string") continue;
        var item = arr[i].toLowerCase();
        if (hasOwnProperty.call(map, item)) {
            arr.splice(i, 1);
            i--;
        }
        else map[item] = true;
    }
}

function shortString(str, nr_chars) {
    if (str.length > nr_chars) {
        return str.substr(9, nr_chars) + '...';
    }
    else {
        return str;
    }
}

function convertToSlug(Text)
{
    return Text
        .toLowerCase()
        .replace(/ /g,'-')
        .replace(/[^\w-]+/g,'')
        ;
}

function getValueBetweenStrings(string, value1, value2) {
    var result = "";
    
    var exploded2 = string.split(value1);
    if (exploded2.length > 1) {
        var exploded3 = exploded2[1].split(value2);
        result = exploded3[0];
    }
    
    if (typeof(result) == "undefined")
        result = "";
    
    return result;
}

function isNumber(n) {
  return !isNaN(parseFloat(n)) && isFinite(n);
}