﻿/// <reference path="/dev/vejis.intellisense.js" />

module_("file", function () {
    this.writeText = writeText;
    this.writeBytes = writeBytes;
    this.readText = readText;
    this.getAvailableFile = getAvailableFile;
    this.getFile = getFile;

    function writeText(path, content) {
        var file = getFile(path);

        try {
            var stream = new air.FileStream();
            stream.open(file, "write");

            content = content.replace(/\r?\n/g, "\r\n");
            stream.writeUTFBytes(content);
            stream.close();
            return true;
        }
        catch (e) {
            message.alert("An error occurred, maybe you should close the opening file?");
            return false;
        }
    }

    function writeBytes(path, bytes) {
        var file = getFile(path);

        try {
            var stream = new air.FileStream();
            stream.open(file, "write");
            stream.writeBytes(bytes);
            stream.close();
            return true;
        }
        catch (e) {
            message.alert("An error occurred, maybe you should close the opening file?");
            return false;
        }
    }

    function readText(path) {
        var file = getFile(path);

        var data;
        try {
            var stream = new air.FileStream();
            stream.open(file, "read");
            data = stream.readUTFBytes(stream.bytesAvailable);
            stream.close();
        }
        catch (e) {
            data = "";
        }

        return data;
    }

    function getAvailableFile(dir, nameTpl) {
        if (typeof dir == "string")
            dir = new air.File(dir);
        var file;
        var i = 1;
        do file = dir.resolvePath(nameTpl.replace("*", i++));
        while (file.exists);
        return file;
    }

    function getFile(path) {
        var file;
        if (typeof path == "string") {
            file = new air.File(path);
        }
        else {
            file = path;
        }

        return file;
    }
});