﻿require_("script/vejis/dom.js");
require_("script/ui.js");
require_("script/file.js");
require_("script/http-request.js");

use_("http-request", "dom", function (hr, dom) {
    module_("google-hr", function () {
        var showingCaptcha = false;
        var requestQueue = [];

        this.class_("Request", function () {
            var ohr = {
                send: this.send,
                open: this.open,
                dispose: this.dispose
            };

            var info = {
                method: undefined,
                url: undefined,
                data: undefined,
                callback: undefined
            };

            this.dispose = _("dispose", function () {
                ohr.dispose();
                delete ohr.send;
                delete ohr.open;
                delete ohr.dispose;
            });

            //override open
            this.open = _("open", String, String, function (method, url) {
                info.method = method;
                info.url = url;
                return ohr.open.call(this, method, url);
            });

            //override send
            this.send = _("send", Function, function (callback) {
                info.data = undefined;
                info.callback = callback;
                return ohr.send.call(this, null, gCallback);
            });

            this._("send", nul_(Object), Function, function (data, callback) {
                info.data = data;
                info.callback = callback;
                return ohr.send.call(this, data, gCallback);
            });

            function gCallback() {
                //if (req.error)
                //    air.trace("http request error");

                var url = this.url;
                var re = /^http:\/\/(www\.google(?:\.\w+)+)\/sorry/;

                //air.trace(url);
                var groups = re.exec(url);

                if (url && groups) {
                    showCaptcha(function () {
                        ohr.open.call(this, info.method, info.url);
                        ohr.send.call(this, info.data, gCallback);
                    }, groups[1]);
                }
                else
                    info.callback.apply(this, arguments);
            }
        }).inherit_(hr.Request);

        /* DEBUG CODE
        setTimeout(function () {
            showCaptcha(function () { });
        }, 1000);
        //*/

        function showCaptcha(callback, host) {
            requestQueue.push(callback);

            if (showingCaptcha) return;
            showingCaptcha = true;

            var useManual = false;

            use_("ui", "file", function (ui, file) {
                var eles = ui.eles;

                var wrapper = eles.captchaWrapper;
                var autoWrapper = eles.captchaAutoWrapper;
                var status = eles.captchaSolveStatus;
                var manualWrapper = eles.captchaManualWrapper;
                var img = eles.captchaImage;
                var input = eles.captchaInput;

                dom.hide(manualWrapper);
                dom.show(wrapper, autoWrapper);

                var dbcData = ui.data("common.deathbycaptcha");

                var username = dbcData("username");
                var password = dbcData("password");

                var dcpData = ui.data("common.decaptcher");

                var username2 = dcpData("username");
                var password2 = dcpData("password");

                if (username && password && ui.data("common.which_captcha_system") == "deathbycaptcha")
                    processDeathByCaptcha();
                else if (username2 && password2 && ui.data("common.which_captcha_system") == "decaptcher")
                    processDecaptcher();
                else
                    processManual();

                function processDeathByCaptcha() {
                    if (useManual) {
                        processManual();
                        return;
                    }
                    wrapper.style.marginTop = -wrapper.offsetHeight / 2 + "px";

                    status.innerHTML = "fetching";
                    fetchCaptcha(solve);

                    function solve(id, bytes) {
                        status.innerHTML = "uploading";

                        var query = {
                            username: username,
                            password: password
                        };

                        var data = new air.ByteArray();
                        var boundary = getRandomString(32);
                        var rn = "\r\n";

                        forin_(query, function (value, name) {
                            data.writeUTFBytes(
                                "--" + boundary + rn +
                                'Content-Disposition: form-data; name="' + name + '"' + rn +
                                rn +
                                value + rn
                            );
                        });

                        var fileFieldName = "captchafile";

                        data.writeUTFBytes(
                            "--" + boundary + rn +
                            'Content-Disposition: form-data; name="' + fileFieldName + '"; filename="' + id + '"' + rn +
                            "Content-Type: application/octet-stream" + rn +
                            rn
                        );

                        data.writeBytes(bytes);
                        data.writeUTFBytes(rn + "--" + boundary + "--" + rn);

                        var req = new hr.Request();

                        req.open("post", "http://api.dbcapi.me/api/captcha");
                        req.setRequestHeader("Content-Type", "multipart/form-data; boundary=" + boundary);
                        req.setRequestHeader("Accept", "application/json");

                        req.autoRedirect = false;

                        var solveUrl;
                        var firstWait = 10000;
                        var wait = 2000;
                        req.send(data, function () {
                            var statusCode = this.status;
                            var text = this.responseText;
                            solveUrl = this.location;
                            this.dispose();

                            if (statusCode >= 500) {
                                if (/maintenance/i.test(text)) {
                                    message.alert("The DeathByCaptcha server seems to be under maintenace, please enter the captcha manually.", function () {
                                        useManual = true;
                                        processDeathByCaptcha();
                                    });
                                }
                                else {
                                    processDeathByCaptcha();
                                }
                                return;
                            }
                            else if (statusCode == 403) {
                                useManual = true;
                                try {
                                    var data = eval("(" + text + ")");
                                    var msg;
                                    if (data.error == "not-logged-in") {
                                        msg = "The DeathByCaptcha account you entered seems to be invalid, please enter a valid one in settings.";
                                        dbcData("password", "");
                                    }
                                    else {
                                        msg = "It seems that you don't have enough DeathByCaptcha credits.";
                                    }

                                    message.alert(msg, function () {
                                        processDeathByCaptcha();
                                    });
                                    return;
                                }
                                catch (e) { }

                                processDeathByCaptcha();
                                return;
                            }
                            else if (statusCode != 303) {
                                //useManual = true;
                                processDeathByCaptcha();
                                return;
                            }

                            status.innerHTML = "solving, takes about 10 seconds";
                            setTimeout(fetchText, firstWait);
                        });
                        req = null;

                        function fetchText() {
                            var req = new hr.Request();

                            req.open("get", solveUrl);
                            req.setRequestHeader("Accept", "application/json");

                            req.send(function () {
                                if (this.status != 200) {
                                    this.dispose();
                                    useManual = true;
                                    processDeathByCaptcha();
                                    return;
                                }

                                var json = this.responseText;
                                this.dispose();
                                var result;

                                try {
                                    result = eval("(" + json + ")");
                                } catch (e) {
                                    useManual = true;
                                    processDeathByCaptcha();
                                    return;
                                }

                                if (result.text) {
                                    submit(id, result.text, function (done) {
                                        if (done)
                                            submitCallback(true);
                                        else {
                                            report(result.captcha);
                                            processDeathByCaptcha();
                                        }
                                    });
                                }
                                else
                                    setTimeout(fetchText, wait);
                            });
                        }
                    }

                    function report(captcha) {
                        var query = new hr.FormData();

                        query.set({
                            username: username,
                            password: password
                        });

                        var req = new hr.Request();
                        req.open("post", "http://api.dbcapi.me/api/captcha/" + captcha + "/report");
                        req.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
                        req.send(query, function () {
                            this.dispose();
                        });
                        req = null;
                    }
                }

                function processDecaptcher() {
                    if (useManual) {
                        processManual();
                        return;
                    }
                    wrapper.style.marginTop = -wrapper.offsetHeight / 2 + "px";

                    status.innerHTML = "fetching";
                    fetchCaptcha(solve);

                    function solve(id, bytes) {
                        status.innerHTML = "uploading";

                        var query = {
                            "function": "picture2",
                            username: username2,
                            password: password2,
                            print_format: "line"
                        };

                        var data = new air.ByteArray();
                        var boundary = getRandomString(32);
                        var rn = "\r\n";

                        forin_(query, function (value, name) {
                            data.writeUTFBytes(
                                "--" + boundary + rn +
                                'Content-Disposition: form-data; name="' + name + '"' + rn +
                                rn +
                                value + rn
                            );
                        });

                        var fileFieldName = "pict";

                        data.writeUTFBytes(
                            "--" + boundary + rn +
                            'Content-Disposition: form-data; name="' + fileFieldName + '"; filename="' + id + '"' + rn +
                            "Content-Type: application/octet-stream" + rn +
                            rn
                        );

                        data.writeBytes(bytes);
                        data.writeUTFBytes(rn + "--" + boundary + "--" + rn);

                        var req = new hr.Request();

                        req.open("post", "http://poster.de-captcher.com");
                        req.setRequestHeader("Content-Type", "multipart/form-data; boundary=" + boundary);
                        req.setRequestHeader("Accept", "application/json");

                        req.autoRedirect = false;

                        var solveUrl;
                        var firstWait = 10000;
                        var wait = 2000;
                        
                        status.innerHTML = "solving, takes about 10 seconds";
                        
                        req.send(data, function () {
                            var statusCode = this.status;
                            var text = this.responseText;
                            solveUrl = this.location;
                            this.dispose();

                            if (statusCode >= 500) {
                                if (/maintenance/i.test(text)) {
                                    message.alert("The De-captcher server seems to be under maintenace, please enter the captcha manually.", function () {
                                        useManual = true;
                                        processDecaptcher();
                                    });
                                }
                                else {
                                    processDecaptcher();
                                }
                                return;
                            }
                            else {
                                if (IsEmpty(text)) {
                                    message.alert("The De-captcher account you entered seems to be invalid, please enter a valid one in settings.", function () {
                                        dcpData("password", "");
                                        useManual = true;
                                        processDecaptcher();
                                    });
                                    return;
                                }
                                else {
                                    var exploded = text.split("|");
                                    if (exploded.length < 6) {
                                        message.alert("The De-captcher server seems to have some issues, please enter the captcha manually.", function () {
                                            useManual = true;
                                            processDecaptcher();
                                        });
                                    }
                                    else {
                                        var captcha_text = (typeof(exploded[5]) == "undefined") ? "" : exploded[5];
                                        if (captcha_text) {
                                            submit(id, captcha_text, function (done) {
                                                if (done)
                                                    submitCallback(true);
                                                else {
                                                    processDecaptcher();
                                                }
                                            });
                                        }
                                        else {
                                            processDecaptcher();
                                        }
                                    }
                                }
                            }
                        });
                    }
                }

                function processManual() {
                    useManual = true;

                    dom.hide(autoWrapper);
                    dom.show(manualWrapper);
                    wrapper.style.marginTop = -wrapper.offsetHeight / 2 + "px";

                    img.style.visibility = "hidden";

                    input.onclick = null;
                    input.value = "";
                    input.disabled = false;
                    input.focus();

                    fetchCaptcha(function (id, bytes) {
                        var path = "app-storage:/captcha-" + id;
                        var imgFile = new air.File(path);

                        file.writeBytes(imgFile, bytes);

                        img.src = path;
                        img.onload = function () {
                            imgFile.deleteFileAsync();
                            img.style.visibility = "visible";
                        };

                        input.onkeypress = function (e) {
                            if (e.keyCode == 13) {
                                input.disabled = true;
                                input.blur();
                                submit(id, input.value, submitCallback);
                            }
                        };
                    });
                }

                function fetchCaptcha(callback) {
                    var req = new hr.Request();
                    var id = Math.floor(Math.random() * 10000000000000000);
                    
                    var url = "http://" + (host || "www.google.com") + "/sorry/image?id=" + id;

                    req.open("get", url);
                    req.send(function () {
                        if (this.status != 200)
                            fetchCaptcha(callback);
                        else
                            callback(id, this.responseBody);

                        this.dispose();
                    });

                    req = null;
                }

                function submitCallback(done) {
                    if (done) {
                        dom.hide(wrapper);
                        for (var i = 0; i < requestQueue.length; i++)
                            requestQueue[i]();
                        requestQueue.length = 0;
                        showingCaptcha = false;
                    }
                    else
                        processDeathByCaptcha();
                }
            });

            function submit(id, value, callback) {
                var query = new hr.FormData();

                query.set({
                    "continue": "http://" + (host || "www.google.com"),
                    id: id,
                    captcha: value,
                    submit: "Submit"
                });

                var url = "http://" + (host || "www.google.com") + "/sorry/Captcha?" + query;

                var req = new hr.Request();
                req.autoRedirect = false;

                req.open("get", url);
                req.send(function () {
                    if (this.error || this.status != 200)
                        callback(false);
                    else
                        callback(true);

                    this.dispose();
                });
                req = null;
            }
        }
    });
});