﻿/// <reference path="/dev/vejis.intellisense.js" />

require_("script/harvest/harvest.js");
require_("script/analyze/analyze.js");
require_("script/ui.js");
require_("script/file.js");
require_("script/settings.js");

use_("harvest", "analyze", "ui", "file", "settings",
function (harvest, analyze, ui, file, settings) {
    module_("restore", function () {
        var restoreFile = "app-storage:/restore.json";

        this.saveAndReload = function () {
            settings.save(true);

            var data = {
                //window: {
                //    x: nativeWindow.x,
                //    y: nativeWindow.y
                //},
                harvest: {
                    originText: harvest.options("origin.text"),
                    ideas: harvest.harvestIdeas,
                    resultType: ui.data("harvest.resultType")
                },
                analyze: {
                    domainsText: analyze.options("domainsText"),
                    keywords: analyze.keywords,
                    results: ui.data("analyze.results") || analyzeResultsTable.toCSV(),
                    toggles: analyze.analyzeToggles
                }
            };

            var json = JSON.stringify(data);
            file.writeText(restoreFile, json);

            var location = "index.html?restore";
            //if (windowStatus.status == "maximized") {
            //    location += "&maximized;" + windowStatus.restoreInfo.x + "," + windowStatus.restoreInfo.y;
            //}

            document.location = location;
        };

        this.restore = function () {
            var json = file.readText(restoreFile);

            try {
                new air.File(restoreFile).deleteFile();
            } catch (e) { }

            if (!json) return;

            var data = eval("(" + json + ")");

            //harvest
            harvest.options("origin.text", data.harvest.originText);
            harvest.harvestIdeas = data.harvest.ideas;
            ui.data("harvest.ideasCount", harvest.harvestIdeas.length);
            ui.data("harvest.ideasReady", harvest.harvestIdeas.length > 0);
            ui.data("harvest.resultType", data.harvest.resultType);

            //analyze
            analyze.options("domainsText", data.analyze.domainsText);
            analyze.keywords = data.analyze.keywords;
            ui.data("analyze.keywordsCount", data.analyze.keywords.length);
            ui.data("analyze.results", data.analyze.results);
            //analyze.results = data.analyze.results;
            //analyze.analyzeToggles.place = data.analyze.toggles.place;
            //analyze.analyzeToggles.video = data.analyze.toggles.video;
            //analyze.analyzeToggles.keywordTool = data.analyze.toggles.keywordTool;
            //analyze.analyzeToggles.domainsRank = data.analyze.toggles.domainsRank;

            //nativeWindow.x = data.window.x;
            //nativeWindow.y = data.window.y;
        };
    });
});