﻿/// <reference path="../src/script/vejis/dom.js" />

use_("dom", function (dom) {
    module_("enhanced-table", function () {
        this.class_("Table", function (pub, pri) {
            var that = this;
            var trs = [];
            
            this.trs = [];

            var pos = 0;
            var length = 0;
            var inc = 0;

            var wrapper =
            this.element = document.createElement("div");
            wrapper.className = "enhanced-table-wrapper";
            dom.setStyle(wrapper, {
                position: "relative",
                //boxSizing: "padding-box",
                overflowY: "hidden"
            });

            var scrollBar = document.createElement("div");
            var scrollBarInner = document.createElement("div");
            dom.setStyle(scrollBar, {
                position: "absolute",
                right: "2px", top: "2px", bottom: "14px",
                //right: "0px", top: "0px", bottom: "0px",
                //width: "10px",
                width: "0px",
                overflowY: "scroll", overflowX: "hidden"
            });
            dom.setStyle(scrollBarInner, {
                position: "absolute",
                width: "1px"
            });
            scrollBar.appendChild(scrollBarInner);
            wrapper.appendChild(scrollBar);

            var tableWrapper = document.createElement("div");
            tableWrapper.className = "table-wrapper";
            //tableWrapper.style.width = "100%";
            
            var table = document.createElement("table");
            dom.setStyle(table, {
                //width: "100%",
                //display: "block",
                boxSizing: "border-box"
            });
            var header = document.createElement("tr");
            table.appendChild(header);
            tableWrapper.appendChild(table);
            wrapper.appendChild(tableWrapper);

            this._(opt_(Integer, 300), function (height) {
                if (height > 0) {
                    wrapper.style.height = height + "px";
                }
            });

            var initialized = false;

            this._("initialize", function () {
                //Initialize table
                if (initialized || !wrapper.offsetWidth) {
                    return;
                }

                initialized = true;

                var w = -scrollBar.clientWidth;
                scrollBar.style.width = w + "px";

                that.setSize();
                //wrapper.style.paddingRight = w + 4 + "px";
                //table.style.paddingRight = w + "px";

                onchange();
            });

            this._("setSize", opt_(Number, 0), opt_(Number, 0), function (height, width) {
                //Set height
                if (height > 0) {
                    wrapper.style.height = height + "px";
                }
                if (width > 0) {
                    wrapper.style.width = width + "px";
                }

                var tdW = Math.floor((tableWrapper.offsetWidth - 2) / header.cells.length);
                //air.trace(tableWrapper.offsetWidth);
                //air.trace(tdW);
                //air.trace(tdW);
                table.style.width = tableWrapper.offsetWidth - 2 + "px";
                /*
                for_(header.cells, function (td, i, length) {
                    if (i) {
                        td.style.width = tdW - 9 + "px";
                    }
                    else {
                        td.style.width = (tableWrapper.offsetWidth - 2) - tdW * (length - 1) - 9 + "px";
                    }
                });*/

                onchange();
            });

            this._("raiseChange", function () {
                //Invoke onchange
                onchange();
            });

            //var headerIndex = [];

            this._("setHeader", Object, function (tr) {
                //Set the header tr element
                table.replaceChild(tr, header);
                header = tr;

                //headerIndex.length = 0;

                //table.style.width = "100%";

                for_(header.cells, function (td, i, length) {
                    var line = document.createElement("div");
                    line.className = "adjust-handler";
                    td.insertBefore(line, td.firstChild);

                    var mousedown = false;
                    var startX;
                    var pW;
                    var tW;
                    dom.on(line, "click", function (e) {
                        e.stopPropagation();
                    });
                    dom.on(line, "mousedown", function (e) {
                        mousedown = true;
                        startX = e.clientX;
                        pW = td.offsetWidth;
                        tW = table.offsetWidth;
                    });
                    dom.on(document, "mousemove", function (e) {
                        if (!mousedown) {
                            return;
                        }

                        var diffX = e.clientX - startX;

                        var new_table_width = tW + diffX;
                        var table_parent = $(table).parent();
                        var max_width = (table_parent.width() -2);

                        //air.trace(new_table_width);
                        //air.trace(table_parent.width());

                        if (new_table_width <= max_width) {
                            if (pW - 9 + diffX < 30) {
                                diffX = 30 + 9 - pW;
                            }

                            td.style.width = pW - 9 + diffX + "px";
                            table.style.width = tW + diffX + "px";
                        }
                        else {
                            td.style.width = (pW - 9) + "px";
                            table.style.width = max_width + "px";
                        }
                    });
                    dom.on(document, "mouseup", function () {
                        mousedown = false;
                    });

                    that.setSize();

                    function onmousedown() {

                    }

                    function onmousemove() {

                    }

                    function onmouseup() {

                    }
                });

            });

            this._("insert", List(Object), opt_(Integer, -1), opt_(Boolean, true), function (trEles, pos, raiseChange) {
                //Add some rows
                for_(trEles, function (tr) {
                    tr.uid = inc++;
                });
                trs.splice.apply(trs, [pos < 0 ? trs.length : pos, 0].concat(trEles));
                if (raiseChange) {
                    onchange();
                }
            });

            this._("insert", Object, opt_(Integer, -1), opt_(Boolean, true), function (trEle, pos, raiseChange) {
                //Add a row
                trEle.uid = inc++;
                trs.splice(pos < 0 ? trs.length : pos, 0, trEle);
                if (raiseChange) {
                    onchange();
                }
            });

            this._("setTrs", List(Object), opt_(Boolean, true), function (trEles, raiseChange) {
                //Add all new rows
                trs = trEles;
                if (raiseChange) {
                    onchange();
                }
            });

            this._("sortBy", Integer, Boolean, function (index, asc) {
                //Sort table by a specific column

                var compare =
                    asc ?
                    function (trA, trB) {
                        var a = trA.cells[index].value;
                        var b = trB.cells[index].value;

                        return a == b ? 0 : a > b ? 1 : -1;
                    } :
                    function (trA, trB) {
                        var a = trA.cells[index].value;
                        var b = trB.cells[index].value;

                        return a == b ? 0 : a < b ? 1 : -1;
                    };

                trs.sort(compare);
                pos = 0;
                onchange();

                return trs;
            });



            this._("sortBy", Integer, Boolean, String, function (index, asc, type) {
                //Sort table by a specific column

                var compare =
                    asc ?
                    function (trA, trB) {
                        var a = trA.cells[index].value;
                        var b = trB.cells[index].value;

                        if (type == "string") {
                            a = strip_tags(a);
                            b = strip_tags(b);
                        }
                        else if (type == "number") {
                            a = parseInt(a);
                            b = parseInt(b);
                        }

                        return a == b ? 0 : a > b ? 1 : -1;
                    } :
                    function (trA, trB) {
                        var a = trA.cells[index].value;
                        var b = trB.cells[index].value;

                        if (type == "string") {
                            a = strip_tags(a);
                            b = strip_tags(b);
                        }
                        else if (type == "number") {
                            a = parseInt(a);
                            b = parseInt(b);
                        }

                        return a == b ? 0 : a < b ? 1 : -1;
                    };

                trs.sort(compare);
                pos = 0;
                onchange();

                return trs;
            });

            this._("restoreOrder", function () {
                //Restore the order
                trs.sort(function (trA, trB) {
                    var a = trA.uid;
                    var b = trB.uid;

                    return a == b ? 0 : a > b ? 1 : -1;
                });
                pos = 0;
                onchange();

                return trs;
            });

            this._("toLast", function () {
                //Scroll to the last row
                pos = Math.max(trs.length - 1, 0);
                onchange();
            });

            this._("scrollTo", Integer, function (to) {
                //Scroll to a specified row
                pos = Math.max(Math.min(trs.length - 1, to), 0);
                onchange();
            });

            this._("toFirst", function () {
                //Scroll to the first row
                pos = 0;
                onchange();
                scrollBar.scrollTop = 0;
            });

            this._("refresh", function () {
                //Scroll to the first row
                onchange();
            });

            this._("clear", function () {
                //Remove all the records
                trs.length = 0;
                pos = 0;
                onchange();
            });

            this._("getColumn", Integer, function (index) {
                //Get the values of a column as an array
                var arr = [];

                for_(trs, function (tr) {
                    if (!tr.removed) {
                        arr.push(tr.cells[index].value);
                    }
                });

                return arr;
            });

            var report;

            this._("getReport", function () {
                //Get an array for report, call toCSV first
                return report;
            });

            this._("toCSV", Integer, function (selected_length) {
                //Convert the table to CSV format string

                var lines = [];
                var strs = [];

                report = [];

                var headerIndex = [];

                for_(header.cells, function (cell) {
                    if (cell.value.replace("checkbox", "") == cell.value) {
                        if (cell.value == "Category") {
                            var table_index = $("#video-stats-analyzed-dropdown").val();
                            cell.value = cell.value + ' | ' + $("#video-stats-urls-wrapper div#url_" + table_index).text();
                        }
                        strs.push(strip_tags(csvEncode(cell.value)));
                        headerIndex.push(cell.keyName);
                    }
                });

                lines.push(strs.join(","));

                for_(trs, function (tr) {
                    if (selected_length > 0 && $(tr).find('input[name="search-results-item"]:checked').length == 0) {
                        return;
                    }

                    if (tr.removed || tr.style.displayd == "none") {
                        return;
                    }

                    var strs = [];
                    var item = {};

                    for_(tr.cells, function (cell, i) {
                        if (cell.value.toString().replace("checkbox", "") == cell.value.toString()) {
                            if (headerIndex[i] == "plus_minus") {
                                cell.value = '"' + cell.value + '"';
                            }
                            strs.push(strip_tags(csvEncode(cell.value.toString())));
                            if (headerIndex[i] != "domainsRanking") {
                                item[headerIndex[i]] = cell.value;
                            }
                        }
                    });

                    item["domainsRanking"] = tr.domainsRanking;

                    lines.push(strs.join(","));
                    report.push(item);
                });

                return lines.join("\r\n");


                function csvEncode(str) {
                    if (str == undefined) return "";

                    str = str.toString();

                    str = str.replace(/^[\s\S]*[\r\n",][\s\S]*$/, function (m) {
                        return '"' + m.replace(/"/g, '""') + '"';
                    });

                    /*
                    str = str.replace(/^\+?\d+(\.\d+)?$/g, function (m) {
                    return '="' + m + '"';
                    });
                    */
                    return str;
                }
            });

            dom.on(wrapper, "mousewheel", function (e) {
                if (e.wheelDelta < 0) {
                    pos = Math.max(Math.min(pos + 1, trs.length - 1), 0);
                }
                else {
                    pos = Math.max(pos - 1, 0);
                }
                onchange();
            });

            dom.on(scrollBar, "mousewheel", function (e) {
                e.preventDefault();
            });

            dom.on(scrollBar, "scroll", function (e) {
                pos = Math.round(this.scrollTop / scrollBar.offsetHeight * length);
                onchange(true);
            });

            function onchange(fromScrollBar) {
                if (!initialized || !wrapper.offsetWidth) {
                    return;
                }

                while (table.rows[1]) {
                    table.removeChild(table.rows[1]);
                }

                var i = pos;
                var last = pos;
                var count = 0;
                var count2 = 0;

                if (i >= 0) {
                    while (table.offsetHeight < wrapper.offsetHeight && i < trs.length) {
                        var tr = trs[i];

                        if (tr.removed) {
                            trs.splice(i, 1);
                            continue;
                        }

                        last = i;

                        i++;

                        table.appendChild(tr);
                        count++;
                        if (tr.style.display != "none") count2++;
                    }

                    if (table.offsetHeight < wrapper.offsetHeight) {
                        i = pos - 1;

                        while (table.offsetHeight < wrapper.offsetHeight && i >= 0) {
                            var tr = trs[i];

                            if (tr.removed) {
                                trs.splice(i--, 1);
                                last--;
                                pos--;
                                continue;
                            }

                            i--;

                            table.insertBefore(tr, table.childNodes[1]);
                            count++;
                            if (tr.style.display != "none") count2++;
                            pos--;
                        }

                        pos = Math.max(Math.min(pos + 1, trs.length - 1), 0);

                        if (table.offsetHeight > wrapper.offsetHeight) {
                            table.removeChild(table.rows[1]);
                            count--;
                            if (tr.style.display != "none") count2--;
                        }
                    }
                    else if (table.offsetHeight > wrapper.offsetHeight) {
                        count--;
                        if (tr.style.display != "none") count2--;
                        last--;
                        //table.removeChild(table.rows[table.rows.length - 1]);
                    }
                }

                length = count2;

                var displayedTrs = [];
                for (var i in trs) {
                    var tr = trs[i];
                    if (tr.style.display != "none")
                        displayedTrs.push(tr);
                }

                var innerHeight = count2 > 0 ? scrollBar.offsetHeight * displayedTrs.length / count2 : 0;
                scrollBarInner.style.height = innerHeight + "px";

                if (!fromScrollBar) {
                    var top = displayedTrs.length > 0 ? (last - count2 + 1) / displayedTrs.length * innerHeight : 0;
                    scrollBar.scrollTop = top;
                }
                
                this.trs = trs;
            }
        });
    });
});
